#!/usr/bin/python3 

import PyTango
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import os

sogliauno = 70 # % per sfondo giallo
sogliadue = 90 # % per sfondo rosso

dev = {}
try:
    dev['calendario_sl'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/laser/calendar_sl.01')
    dev['calendario_slu'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/laser/calendar_slu.01')
    selettore_sl = dev['calendario_sl'].activityNum
    selettore_slu = dev['calendario_slu'].activityNum
except:
    print('dev')
devpil = {}
try:    
    devpil['pillegendtiming'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/pil/feedback/fbdelay_pil.01')
    devpil['feedbackcarica'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/f/feedback/charge_fb.01')
except:
    print('devpil')
devlh = {}
try:
    devlh['lhpointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/lhl/feedback/mimofb_lhl.01')
except:
    print('devlh')
devsl = {}
if selettore_sl == 1: #ELITE1_OPA_FEL1
    try:
        devsl['slelite1input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.02')
        devsl['slelite1output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.01')
        devsl['slelite1timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.01')
        devsl['fel1energyopa'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fb_opa_energy_fel01.01')
        devsl['fel1pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel01.01')
    except:
        print('devsl')
elif selettore_sl == 2: #ELITE1_OPA_FEL1_ELITE2_SLU
    try:
        devsl['slelite1input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.02')
        devsl['slelite1output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.01')
        devsl['slelite1timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.01')
        devsl['slelite2input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.01')
        devsl['slelite2output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.02')
        devsl['slelite2timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.02')
        devsl['fel1energyopa'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fb_opa_energy_fel01.01')
        devsl['fel1pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel01.01')
    except:
        print('devsl')
elif selettore_sl == 3: #ELITE1_THG_FEL1
    try:
        devsl['slelite1input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.02')
        devsl['slelite1output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.01')
        devsl['slelite1timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.01')
        devsl['fel1pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel01.01')
    except:
        print('devsl')
elif selettore_sl == 4: #ELITE1_THG_FEL1_ELITE2_SLU
    try:
        devsl['slelite1input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.02')
        devsl['slelite1output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.01')
        devsl['slelite1timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.01')
        devsl['slelite2input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.01')
        devsl['slelite2output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.02')
        devsl['slelite2timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.02')
        devsl['fel1pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel01.01')
    except:
        print('devsl')
elif selettore_sl == 5: #ELITE1_THGOPA_FEL1
    try:
        devsl['slelite1input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.02')
        devsl['slelite1output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.01')
        devsl['slelite1timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.01')
        devsl['fel1pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel01.01')
    except:
        print('devsl')
    #feedback pointing thg
elif selettore_sl == 6: #ELITE1_THGOPA_FEL1_ELITE2_SLU 
    try:
        devsl['slelite1input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.02')
        devsl['slelite1output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.01')
        devsl['slelite1timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.01')
        devsl['slelite2input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.01')
        devsl['slelite2output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.02')
        devsl['slelite2timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.02')
        devsl['fel1pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel01.01')
    except:
        print('devsl')
    #feedback pointing thg
elif selettore_sl == 7: #ELITE2_THG_FEL2
    try:
        devsl['slelite2input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.01')
        devsl['slelite2output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.02')
        devsl['slelite2timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.02')
        devsl['fel2pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel02.01')
    except:
        print('devsl')
elif selettore_sl == 8: #ELITE2_THG_FEL2_ELITE1_SLU
    try:
        devsl['slelite2input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.01')
        devsl['slelite2output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.02')
        devsl['slelite2timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.02')
        devsl['slelite1input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.02')
        devsl['slelite1output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.01')
        devsl['slelite1timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.01')
        devsl['fel2pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel02.01')
    except:
        print('devsl')
elif selettore_sl == 9: #ELITE2_OPA_FEL2
    try:
        devsl['slelite2input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.01')
        devsl['slelite2output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.02')
        devsl['slelite2timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.02')
        devsl['fel2energyopa'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fb_opa_energy_fel02.01')
        devsl['fel2pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel02.01')
    except:
        print('devsl')
elif selettore_sl == 10: #ELITE2_OPA_FEL2_ELITE1_SLU
    try:
        devsl['slelite2input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.01')
        devsl['slelite2output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.02')
        devsl['slelite2timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.02')
        devsl['slelite1input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.02')
        devsl['slelite1output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.01')
        devsl['slelite1timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.01')
        devsl['fel2energyopa'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fb_opa_energy_fel02.01')
        devsl['fel2pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel02.01')
    except:
        print('devsl')
elif selettore_sl == 11: #ELITE2_THG_FEL2_ELITE1_EEHG
    try:
        devsl['slelite2input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.01')
        devsl['slelite2output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.02')
        devsl['slelite2timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.02')
        devsl['slelite1input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.02')
        devsl['slelite1output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.01')
        devsl['slelite1timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.01')
        devsl['fel2pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel02.01')
    except:
        print('devsl')
    #feedback eehg
elif selettore_sl == 0: #SHUTDOWN
    devsl = {}
else:
    try:
        devsl['slelite1input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.02')
        devsl['slelite1output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.01')
        devsl['slelite1timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.01')
        devsl['slelite2input'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_osc.01')
        devsl['slelite2output'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_elite.02')
        devsl['slelite2timing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fbdelay_sl.02')
        devsl['fel1energyopa'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fb_opa_energy_fel01.01')
        devsl['fel1pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel01.01')
        devsl['fel2energyopa'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/fb_opa_energy_fel02.01')
        devsl['fel2pointing'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/sl/feedback/rtltf_fel02.01')
    except:
        print('devsl')
###################### MIMO FEEDBACK
devslu = {}
if selettore_slu == 1 or selettore_slu == 7: #ELITE2_TIMER
    try:
        devslu['slutimer'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_tmr_slu.01')
    except:
        print('devslu')
elif selettore_slu == 2 or selettore_slu == 8: #ELITE2_TIMEX
    try:
        devslu['slutimez'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_tmx_slu.01')
    except:
        print('devslu')
elif selettore_slu == 3 or selettore_slu == 9: #ELITE2_DIPRI
    try:
        devslu['sludiproi'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_diproi_slu.01')
    except:
        print('devslu')
elif selettore_slu == 4 or selettore_slu == 10: #ELITE2_LDM
    try:
        devslu['sluldm'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_ldm_slu.01')
    except:
        print('devslu')
elif selettore_slu == 5 or selettore_slu == 11: #ELITE2_TOTEM
    try:
        devslu['slutotem'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_totem_slu.01')
    except:
        print('devslu')
elif selettore_slu == 6 or selettore_slu == 12: #ELITE2_MAGNEDYN
    try:
        devslu['slumagnedyn'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_mag_slu.01')
    except:
        print('devslu')
elif selettore_slu == 0: #SHUTDOWN
    devslu = {}
else:
    try:
        devslu['slutimer'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_tmr_slu.01')
        devslu['slutimez'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_tmx_slu.01')
        devslu['sludiproi'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_diproi_slu.01')
        devslu['sluldm'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_ldm_slu.01')
        devslu['slumagnedyn'] = PyTango.DeviceProxy('srv-tango-srf-01:20000/slu/feedback/mimofb_mag_slu.01')
    except:
        print('devslu')

class MainWindow(QDialog):
    def __init__(self, parent = None):
        super(MainWindow, self).__init__(parent)
        self.riquadrodiselezione = QGroupBox()
        self.selezionetutti = QRadioButton("ALL")
        self.selezionestandard = QRadioButton("Standard")
        loselezione = QHBoxLayout()
        loselezione.addWidget(self.selezionetutti)
        loselezione.addWidget(self.selezionestandard)
        self.riquadrodiselezione.setLayout(loselezione)
        self.riquadrodipil = QGroupBox('PIL')
        self.riquadrodipil.setStyleSheet("background-color: rgb(255, 255, 200)")
        lopil = QGridLayout()
        for indice in range(len(devpil)):
            mappa = list(devpil.items())[indice][1].adm_name().split('/') #dal tipo di device ricostruisco che bottoni mettere
            tmpnome = list(devpil.items())[indice][1].name().split('/') #leggo nome device
            nomedicomodoperpannello = tmpnome[2].replace('.', '') #creo nome per elementi grafici del pannello
            exec('self.' + nomedicomodoperpannello + '_bottone = QPushButton("' + tmpnome[2] + '")') # creo il tasto per lanciare il pannello
            exec('lopil.addWidget(self.' + nomedicomodoperpannello + '_bottone, ' + str(indice+1) + ', 0, 1, 1)') #schiaffo l'elemento grafico nel layout
            exec('self.' + nomedicomodoperpannello + '_stato = QLineEdit("")') # creo il il campo per scrivere lo stato
            exec('lopil.addWidget(self.' + nomedicomodoperpannello + '_stato, ' + str(indice+1) + ', 1, 1, 1)') #schiaffo l'elemento grafico nel layout
            exec('self.' + nomedicomodoperpannello + '_percentuale = QLineEdit("%")') # creo il il campo per scrivere %
            exec('lopil.addWidget(self.' + nomedicomodoperpannello + '_percentuale, ' + str(indice+1) + ', 2, 1, 1)') #schiaffo l'elemento grafico nel layout
            if mappa[4] == 'rtltf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/ftfmaster' + list(devpil.items())[indice][1].name() + ' --laser &"))') #creo comando apri pannello
            elif mappa[4] == 'mimofb-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/mimo-fb-gui ' + list(devpil.items())[indice][1].name() +' &"))') #creo comando apri pannello
            elif mappa[4] == 'sequencerconf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/usr/local/tango-9.3.3/bin/atkpanel ' + list(devpil.items())[indice][1].name() +' &"))') #creo comando apri pannello
        self.riquadrodipil.setLayout(lopil)
        self.riquadrodilhl = QGroupBox('LHL')
        self.riquadrodilhl.setStyleSheet("background-color: rgb(255, 200, 200)")
        lolh = QGridLayout()
        for indice in range(len(devlh)):
            mappa = list(devlh.items())[indice][1].adm_name().split('/') #dal tipo di device ricostruisco che bottoni mettere
            tmpnome = list(devlh.items())[indice][1].name().split('/') #leggo nome device
            nomedicomodoperpannello = tmpnome[2].replace('.', '') #creo nome per elementi grafici del pannello
            exec('self.' + nomedicomodoperpannello + '_bottone = QPushButton("' + tmpnome[2] + '")') # creo il tasto per lanciare il pannello
            exec('lolh.addWidget(self.' + nomedicomodoperpannello + '_bottone, ' + str(indice+1) + ', 0, 1, 1)') #schiaffo l'elemento grafico nel layout
            exec('self.' + nomedicomodoperpannello + '_stato = QLineEdit("")') # creo il il campo per scrivere lo stato
            exec('lolh.addWidget(self.' + nomedicomodoperpannello + '_stato, ' + str(indice+1) + ', 1, 1, 1)') #schiaffo l'elemento grafico nel layout
            exec('self.' + nomedicomodoperpannello + '_percentuale = QLineEdit("%")') # creo il il campo per scrivere %
            exec('lolh.addWidget(self.' + nomedicomodoperpannello + '_percentuale, ' + str(indice+1) + ', 2, 1, 1)') #schiaffo l'elemento grafico nel layout
            if mappa[4] == 'rtltf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/ftfmaster ' + list(devlh.items())[indice][1].name() +' --laser &"))') #creo comando apri pannello
            elif mappa[4] == 'dcf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/fbdelay ' + list(devlh.items())[indice][1].name() +' &"))') #creo comando apri pannello
            elif mappa[4] == 'mimofb-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/mimo-fb-gui ' + list(devlh.items())[indice][1].name() +' &"))') #creo comando apri pannello
            elif mappa[4] == 'sequencerconf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/usr/local/tango-9.3.3/bin/atkpanel ' + list(devlh.items())[indice][1].name() +' &"))') #creo comando apri pannello
            elif mappa[4] == 'lefb-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/lef ' + list(devlh.items())[indice][1].name() +' &"))') #creo comando apri pannello
        self.riquadrodilhl.setLayout(lolh)
        self.riquadrodisl = QGroupBox('SEED')
        self.riquadrodisl.setStyleSheet("background-color: rgb(200, 255, 255)")
        losl = QGridLayout()
        for indice in range(len(devsl)):
            mappa = list(devsl.items())[indice][1].adm_name().split('/') #dal tipo di device ricostruisco che bottoni mettere
            tmpnome = list(devsl.items())[indice][1].name().split('/') #leggo nome device
            nomedicomodoperpannello = tmpnome[2].replace('.', '') #creo nome per elementi grafici del pannello
            exec('self.' + nomedicomodoperpannello + '_bottone = QPushButton("' + tmpnome[2] + '")') # creo il tasto per lanciare il pannello
            exec('losl.addWidget(self.' + nomedicomodoperpannello + '_bottone, ' + str(indice+1) + ', 0, 1, 1)') #schiaffo l'elemento grafico nel layout
            exec('self.' + nomedicomodoperpannello + '_stato = QLineEdit("")') # creo il il campo per scrivere lo stato
            exec('losl.addWidget(self.' + nomedicomodoperpannello + '_stato, ' + str(indice+1) + ', 1, 1, 1)') #schiaffo l'elemento grafico nel layout
            exec('self.' + nomedicomodoperpannello + '_percentuale = QLineEdit("%")') # creo il il campo per scrivere %
            exec('losl.addWidget(self.' + nomedicomodoperpannello + '_percentuale, ' + str(indice+1) + ', 2, 1, 1)') #schiaffo l'elemento grafico nel layout
            if mappa[4] == 'rtltf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/ftfmaster ' + list(devsl.items())[indice][1].name() + ' --laser &"))') #creo comando apri pannello
            elif mappa[4] == 'dcf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/fbdelay ' + list(devsl.items())[indice][1].name() +' &"))') #creo comando apri pannello
            elif mappa[4] == 'mimofb-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/mimo-fb-gui ' + list(devsl.items())[indice][1].name() +' &"))') #creo comando apri pannello
            elif mappa[4] == 'sequencerconf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/usr/local/tango-9.3.3/bin/atkpanel ' + list(devsl.items())[indice][1].name() +' &"))') #creo comando apri pannello
            elif mappa[4] == 'lefb-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/lef ' + list(devsl.items())[indice][1].name() +' &"))') #creo comando apri pannello
        self.riquadrodisl.setLayout(losl)
        self.riquadrodislu = QGroupBox('SLU')
        self.riquadrodislu.setStyleSheet("background-color: rgb(200, 255, 200)")
        loslu = QGridLayout()
        for indice in range(len(devslu)):
            mappa = list(devslu.items())[indice][1].adm_name().split('/') #dal tipo di device ricostruisco che bottoni mettere
            tmpnome = list(devslu.items())[indice][1].name().split('/') #leggo nome device
            nomedicomodoperpannello = tmpnome[2].replace('.', '') #creo nome per elementi grafici del pannello
            exec('self.' + nomedicomodoperpannello + '_bottone = QPushButton("' + tmpnome[2] + '")') # creo il tasto per lanciare il pannello
            exec('loslu.addWidget(self.' + nomedicomodoperpannello + '_bottone, ' + str(indice+1) + ', 0, 1, 1)') #schiaffo l'elemento grafico nel layout
            exec('self.' + nomedicomodoperpannello + '_stato = QLineEdit("")') # creo il il campo per scrivere lo stato
            exec('loslu.addWidget(self.' + nomedicomodoperpannello + '_stato, ' + str(indice+1) + ', 1, 1, 1)') #schiaffo l'elemento grafico nel layout
            exec('self.' + nomedicomodoperpannello + '_percentuale = QLineEdit("%")') # creo il il campo per scrivere %
            exec('loslu.addWidget(self.' + nomedicomodoperpannello + '_percentuale, ' + str(indice+1) + ', 2, 1, 1)') #schiaffo l'elemento grafico nel layout
            if mappa[4] == 'rtltf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/ftfmaster ' + list(devslu.items())[indice][1].name() + ' --laser &"))') #creo comando apri pannello
            elif mappa[4] == 'dcf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/fbdelay ' + list(devslu.items())[indice][1].name() +' &"))') #creo comando apri pannello
            elif mappa[4] == 'mimofb-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/mimo-fb-gui ' + list(devslu.items())[indice][1].name() +' &"))') #creo comando apri pannello
            elif mappa[4] == 'sequencerconf-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/usr/local/tango-9.3.3/bin/atkpanel ' + list(devslu.items())[indice][1].name() +' &"))') #creo comando apri pannello
            elif mappa[4] == 'lefb-srv':
                exec('self.' + nomedicomodoperpannello + '_bottone.clicked.connect(lambda: os.system("/runtime/bin/lef ' + list(devslu.items())[indice][1].name() +' &"))') #creo comando apri pannello
        self.riquadrodislu.setLayout(loslu)
        loglobale = QGridLayout()
        loglobale.addWidget(self.riquadrodipil, 1, 0, 1, 1)
        loglobale.addWidget(self.riquadrodilhl, 2, 0, 1, 1)
        loglobale.addWidget(self.riquadrodisl, 1, 1, 3, 1)
        loglobale.addWidget(self.riquadrodislu, 3, 0, 1, 1)
        self.setLayout(loglobale)
        self.setWindowTitle("LASER FEEDBACKs")
        self.show()
        self.timer = QBasicTimer()
        self.timer.start(2000, self)

    def timerEvent(self, event):
        self.update()
        pass
    
    def __del__(self):
        self.timer.stop()
        pass

    def update(self):
        chiavipil = list(devpil.keys())
        for indice in range(len(chiavipil)):
            if str(devpil[chiavipil[indice]]).split('(')[0] == 'MIMOFB':
                percentuale = round(devpil[chiavipil[indice]].ActuatorMaxPercentage, 0)
                exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setText("' + str(percentuale) + ' % ")')
                if percentuale <= sogliauno:
                    exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #00ff00")')
                elif percentuale > sogliauno and percentuale < sogliadue:
                    exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ffff00")')
                elif percentuale >= sogliadue:
                    exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ff0000")')
            elif str(devpil[chiavipil[indice]]).split('(')[0] == 'RTLTF':
                percentuale = round(max(devpil[chiavipil[indice]].CorHorMax, devpil[chiavipil[indice]].CorVerMax), 0)
                exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setText("' + str(percentuale) + ' % ")')
                if percentuale <= sogliauno:
                    exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #00ff00")')
                elif percentuale > sogliauno and percentuale < sogliadue:
                    exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ffff00")')
                elif percentuale >= sogliadue:
                    exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ff0000")')
            stato = str(devpil[chiavipil[indice]].state())
            exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setText("' + stato + '")')
            if stato == 'ON' or stato == 'RUNNING':
                exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #00ff00")')
            elif stato == 'STANDBY' or stato == 'MOVING' or stato == 'WAITING':
                exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ffff00")')
            elif stato == 'OFF':
                exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ffffff")')
            else:
                exec('self.' + list(devpil.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ff0000")')
        
        chiavilhl = list(devlh.keys())
        for indice in range(len(chiavilhl)):
            if str(devlh[chiavilhl[indice]]).split('(')[0] == 'MIMOFB':
                percentuale = round(devlh[chiavilhl[indice]].ActuatorMaxPercentage, 0)
                exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setText("' + str(percentuale) + ' % ")')
                if percentuale <= sogliauno:
                    exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #00ff00")')
                elif percentuale > sogliauno and percentuale < sogliadue:
                    exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ffff00")')
                elif percentuale >= sogliadue:
                    exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ff0000")')
            elif str(devlh[chiavilhl[indice]]).split('(')[0] == 'RTLTF':
                percentuale = round(max(devlh[chiavilhl[indice]].CorHorMax, devlh[chiavilhl[indice]].CorVerMax), 0)
                exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setText("' + str(percentuale) + ' % ")')
                if percentuale <= sogliauno:
                    exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #00ff00")')
                elif percentuale > sogliauno and percentuale < sogliadue:
                    exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ffff00")')
                elif percentuale >= sogliadue:
                    exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ff0000")')
            stato = str(devlh[chiavilhl[indice]].state())
            exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setText("' + stato + '")')
            if stato == 'ON' or stato == 'RUNNING':
                exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #00ff00")')
            elif stato == 'STANDBY' or stato == 'MOVING' or stato == 'WAITING':
                exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ffff00")')
            elif stato == 'OFF':
                exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ffffff")')
            else:
                exec('self.' + list(devlh.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ff0000")')
        
        chiavisl = list(devsl.keys())
        for indice in range(len(chiavisl)):
            if str(devsl[chiavisl[indice]]).split('(')[0] == 'MIMOFB':
                percentuale = round(devsl[chiavisl[indice]].ActuatorMaxPercentage, 0)
                exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setText("' + str(percentuale) + ' % ")')
                if percentuale <= sogliauno:
                    exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #00ff00")')
                elif percentuale > sogliauno and percentuale < sogliadue:
                    exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ffff00")')
                elif percentuale >= sogliadue:
                    exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ff0000")')
            elif str(devsl[chiavisl[indice]]).split('(')[0] == 'RTLTF':
                percentuale = round(max(devsl[chiavisl[indice]].CorHorMax, devsl[chiavisl[indice]].CorVerMax), 0)
                exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setText("' + str(percentuale) + ' % ")')
                if percentuale <= sogliauno:
                    exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #00ff00")')
                elif percentuale > sogliauno and percentuale < sogliadue:
                    exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ffff00")')
                elif percentuale >= sogliadue:
                    exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ff0000")')
            stato = str(devsl[chiavisl[indice]].state())
            exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setText("' + stato + '")')
            if stato == 'ON' or stato == 'RUNNING':
                exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #00ff00")')
            elif stato == 'STANDBY' or stato == 'MOVING' or stato == 'WAITING':
                exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ffff00")')
            elif stato == 'OFF':
                exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ffffff")')
            else:
                exec('self.' + list(devsl.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ff0000")')
        
        chiavislu = list(devslu.keys())
        for indice in range(len(chiavislu)):
            if str(devslu[chiavislu[indice]]).split('(')[0] == 'MIMOFB':
                percentuale = round(devslu[chiavislu[indice]].ActuatorMaxPercentage, 0)
                exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setText("' + str(percentuale) + ' % ")')
                if percentuale <= 60:
                    exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #00ff00")')
                elif percentuale > 60 and percentuale < 80:
                    exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ffff00")')
                elif percentuale >= 80:
                    exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ff0000")')
            elif str(devslu[chiavislu[indice]]).split('(')[0] == 'RTLTF':
                percentuale = round(max(devslu[chiavislu[indice]].CorHorMax, devslu[chiavislu[indice]].CorVerMax), 0)
                exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setText("' + str(percentuale) + ' % ")')
                if percentuale <= 60:
                    exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #00ff00")')
                elif percentuale > 60 and percentuale < 80:
                    exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ffff00")')
                elif percentuale >= 80:
                    exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_percentuale.setStyleSheet("background-color: #ff0000")')
            stato = str(devslu[chiavislu[indice]].state())
            exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setText("' + stato + '")')
            if stato == 'ON' or stato == 'RUNNING':
                exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #00ff00")')
            elif stato == 'STANDBY' or stato == 'MOVING' or stato == 'WAITING':
                exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ffff00")')
            elif stato == 'OFF':
                exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ffffff")')
            else:
                exec('self.' + list(devslu.items())[indice][1].name().split('/')[2].replace('.', '') + '_stato.setStyleSheet("background-color: #ff0000")')


app = QApplication([])
try:
  tmpdim = sys.argv[1]
  tmpdim = tmpdim.split('x')
  dimensione = [float(tmpdim[0]), float(tmpdim[1])]
except:
  screen = QDesktopWidget().screenGeometry()
  dimensione = [screen.width()*0.7, screen.height()*0.7]
font_pannello = QFont("Arial", round(dimensione[0]/160.0), -1, False)
font_grosso = QFont("Arial", round(dimensione[0]/100.0), -1, True)
app.setFont(font_pannello)
main = MainWindow()
main.show()
app.exec_()